Index: sasmodels/models/core_shell_bicelle_elliptical.c
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
+++ sasmodels/models/core_shell_bicelle_elliptical.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -0,0 +1,139 @@
+double form_volume(double radius, double x_core, double thick_rim, double thick_face, double length);
+double Iq(double q,
+          double radius,
+          double x_core,
+          double thick_rim,
+          double thick_face,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld);
+
+
+double Iqxy(double qx, double qy,
+          double radius,
+          double x_core,
+          double thick_rim,
+          double thick_face,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld,
+          double theta,
+          double phi,
+          double psi);
+
+// NOTE that "length" here is the full height of the core!
+double form_volume(double radius, double x_core, double thick_rim, double thick_face, double length)
+{
+    return M_PI*(radius+thick_rim)*(radius*x_core+thick_rim)*(length+2.0*thick_face);
+}
+
+double 
+                Iq(double qq,
+                   double rad,
+                   double x_core,
+                   double radthick,
+                   double facthick,
+                   double length,
+                   double rhoc,
+                   double rhoh,
+                   double rhor,
+                   double rhosolv)
+{
+    double si1,si2,be1,be2;
+     // core_shell_bicelle_elliptical, RKH Dec 2016, based on elliptical_cylinder and core_shell_bicelle
+     // tested against limiting cases of cylinder, elliptical_cylinder and core_shell_bicelle
+     //    const double uplim = M_PI_4;
+    const double halfheight = 0.5*length;
+    //const double va = 0.0;
+    //const double vb = 1.0;
+    // inner integral limits
+    //const double vaj=0.0;
+    //const double vbj=M_PI;
+
+    const double radius_major = rad * x_core;
+    const double rA = 0.5*(square(radius_major) + square(rad));
+    const double rB = 0.5*(square(radius_major) - square(rad));
+    const double dr1 = (rhoc-rhoh)   *M_PI*rad*radius_major*(2.0*halfheight);;
+    const double dr2 = (rhor-rhosolv)*M_PI*(rad+radthick)*(radius_major+radthick)*2.0*(halfheight+facthick);
+    const double dr3 = (rhoh-rhor)   *M_PI*rad*radius_major*2.0*(halfheight+facthick);
+    //const double vol1 = M_PI*rad*radius_major*(2.0*halfheight);
+    //const double vol2 = M_PI*(rad+radthick)*(radius_major+radthick)*2.0*(halfheight+facthick);
+    //const double vol3 = M_PI*rad*radius_major*2.0*(halfheight+facthick);
+
+    //initialize integral
+    double outer_sum = 0.0;
+    for(int i=0;i<76;i++) {
+        //setup inner integral over the ellipsoidal cross-section
+        // since we generate these lots of times, why not store them somewhere?
+        //const double cos_alpha = ( Gauss76Z[i]*(vb-va) + va + vb )/2.0;
+        const double cos_alpha = ( Gauss76Z[i] + 1.0 )/2.0;
+        const double sin_alpha = sqrt(1.0 - cos_alpha*cos_alpha);
+        double inner_sum=0;
+        double sinarg1 = qq*halfheight*cos_alpha;
+        double sinarg2 = qq*(halfheight+facthick)*cos_alpha;
+        si1 = sas_sinx_x(sinarg1);
+        si2 = sas_sinx_x(sinarg2);
+        for(int j=0;j<76;j++) {
+            //76 gauss points for the inner integral (WAS 20 points,so this may make unecessarily slow, but playing safe)
+            //const double beta = ( Gauss76Z[j]*(vbj-vaj) + vaj + vbj )/2.0;
+            const double beta = ( Gauss76Z[j] +1.0)*M_PI_2;
+            const double rr = sqrt(rA - rB*cos(beta));
+            double besarg1 = qq*rr*sin_alpha;
+            double besarg2 = qq*(rr+radthick)*sin_alpha;
+            be1 = sas_2J1x_x(besarg1);
+            be2 = sas_2J1x_x(besarg2);
+            inner_sum += Gauss76Wt[j] *square(dr1*si1*be1 +
+                                              dr2*si2*be2 +
+                                              dr3*si2*be1);
+        }
+        //now calculate outer integral
+        outer_sum += Gauss76Wt[i] * inner_sum;
+    }
+
+    return outer_sum*2.5e-05;
+}
+
+double 
+Iqxy(double qx, double qy,
+          double rad,
+          double x_core,
+          double radthick,
+          double facthick,
+          double length,
+          double rhoc,
+          double rhoh,
+          double rhor,
+          double rhosolv,
+          double theta,
+          double phi,
+          double psi)
+{
+       // THIS NEEDS TESTING
+    double qq, cos_val, cos_mu, cos_nu;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, qq, cos_val, cos_mu, cos_nu);
+    const double dr1 = rhoc-rhoh;
+    const double dr2 = rhor-rhosolv;
+    const double dr3 = rhoh-rhor;
+    const double radius_major = rad*x_core;
+    const double halfheight = 0.5*length;
+    const double vol1 = M_PI*rad*radius_major*length;
+    const double vol2 = M_PI*(rad+radthick)*(radius_major+radthick)*2.0*(halfheight+facthick);
+    const double vol3 = M_PI*rad*radius_major*2.0*(halfheight+facthick);
+
+    // Compute:  r = sqrt((radius_major*cos_nu)^2 + (radius_minor*cos_mu)^2)
+    // Given:    radius_major = r_ratio * radius_minor  
+    // ASSUME the sin_alpha is included in the separate integration over orientation of rod angle
+    const double r = rad*sqrt(square(x_core*cos_nu) + cos_mu*cos_mu);
+    const double be1 = sas_2J1x_x( qq*r );
+    const double be2 = sas_2J1x_x( qq*(r + radthick ) );
+    const double si1 = sas_sinx_x( qq*halfheight*cos_val );
+    const double si2 = sas_sinx_x( qq*(halfheight + facthick)*cos_val );
+    const double Aq = square( vol1*dr1*si1*be1 + vol2*dr2*si2*be2 +  vol3*dr3*si2*be1);
+    //const double vol = form_volume(radius_minor, r_ratio, length);
+    return 1.0e-4 * Aq;
+}
+
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 8afefaee3d363dde220aa55fe83181a73b621f98)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision 8afefaee3d363dde220aa55fe83181a73b621f98)
@@ -0,0 +1,161 @@
+r"""
+Definition
+----------
+
+This model provides the form factor for an elliptical cylinder with a
+core-shell scattering length density profile. Thus this is a variation
+of the core-shell bicelle model, but with an elliptical cylinder for the core.
+Outer shells on the rims and flat ends may be of different thicknesses and 
+scattering length densities. The form factor is normalized by the total particle volume.
+
+
+.. figure:: img/core_shell_bicelle_geometry.png
+
+    Schematic cross-section of bicelle. Note however that the model here
+    calculates for rectangular, not curved, rims as shown below.
+
+.. figure:: img/core_shell_bicelle_parameters.png
+
+   Cross section of model used here. Users will have 
+   to decide how to distribute "heads" and "tails" between the rim, face 
+   and core regions in order to estimate appropriate starting parameters.
+
+Given the scattering length densities (sld) $\rho_c$, the core sld, $\rho_f$,
+the face sld, $\rho_r$, the rim sld and $\rho_s$ the solvent sld, the
+scattering length density variation along the bicelle axis is:
+
+.. math::
+
+    \rho(r) = 
+      \begin{cases} 
+      &\rho_c \text{ for } 0 \lt r \lt R; -L \lt z\lt L \\[1.5ex]
+      &\rho_f \text{ for } 0 \lt r \lt R; -(L+2t) \lt z\lt -L;
+      L \lt z\lt (L+2t) \\[1.5ex]
+      &\rho_r\text{ for } 0 \lt r \lt R; -(L+2t) \lt z\lt -L; L \lt z\lt (L+2t)
+      \end{cases}
+
+The form factor for the bicelle is calculated in cylindrical coordinates, where
+$\alpha$ is the angle between the $Q$ vector and the cylinder axis, and $\psi$ is the angle
+for the ellipsoidal cross section core, to give:
+
+.. math::
+
+    I(Q,\alpha,\psi) = \frac{\text{scale}}{V_t} \cdot
+        F(Q,\alpha, \psi)^2.sin(\alpha) + \text{background}
+
+where a numerical integration of $F(Q,\alpha, \psi)^2.sin(\alpha)$ is carried out over \alpha and \psi for:
+
+.. math::
+
+        \begin{align}    
+    F(Q,\alpha,\psi) = &\bigg[ 
+    (\rho_c - \rho_f) V_c \frac{2J_1(QR'sin \alpha)}{QR'sin\alpha}\frac{sin(QLcos\alpha/2)}{Q(L/2)cos\alpha} \\
+    &+(\rho_f - \rho_r) V_{c+f} \frac{2J_1(QR'sin\alpha)}{QR'sin\alpha}\frac{sin(Q(L/2+t_f)cos\alpha)}{Q(L/2+t_f)cos\alpha} \\
+    &+(\rho_r - \rho_s) V_t \frac{2J_1(Q(R'+t_r)sin\alpha)}{Q(R'+t_r)sin\alpha}\frac{sin(Q(L/2+t_f)cos\alpha)}{Q(L/2+t_f)cos\alpha}
+    \bigg]
+    \end{align} 
+
+where
+
+.. math::
+
+    R'=\frac{R}{\sqrt{2}}\sqrt{(1+X_{core}^{2}) + (1-X_{core}^{2})cos(\psi)}
+    
+    
+and $V_t = \pi.(R+t_r)(Xcore.R+t_r)^2.(L+2.t_f)$ is the total volume of the bicelle, 
+$V_c = \pi.Xcore.R^2.L$ the volume of the core, $V_{c+f} = \pi.Xcore.R^2.(L+2.t_f)$ 
+the volume of the core plus the volume of the faces, $R$ is the radius
+of the core, $Xcore$ is the axial ratio of the core, $L$ the length of the core, 
+$t_f$ the thickness of the face, $t_r$ the thickness of the rim and $J_1$ the usual 
+first order bessel function. The core has radii $R$ and $Xcore.R$ so is circular, 
+as for the core_shell_bicelle model, for $Xcore$ =1. Note that you may need to 
+limit the range of $Xcore$, especially if using the Monte-Carlo algorithm, as 
+setting radius to $R/Xcore$ and axial ratio to $1/Xcore$ gives an equivalent solution!
+
+The output of the 1D scattering intensity function for randomly oriented
+bicelles is then given by integrating over all possible $\alpha$ and $\psi$.
+
+For oriented bicellles the *theta*, *phi* and *psi* orientation parameters only appear when fitting 2D data, 
+see the :ref:`elliptical-cylinder` model for further information.
+
+
+.. figure:: img/elliptical_cylinder_angle_definition.jpg
+
+    Definition of the angles for the oriented core_shell_bicelle_elliptical model.
+    Note that *theta* and *phi* are currently defined differently to those for the core_shell_bicelle model.
+
+
+References
+----------
+
+.. [#]
+
+Authorship and Verification
+----------------------------
+
+* **Author:** Richard Heenan **Date:** December 14, 2016
+* **Last Modified by:**  Richard Heenan **Date:** December 14, 2016
+* **Last Reviewed by:**  Richard Heenan BEWARE 2d data yet to be checked **Date:** December 14, 2016
+"""
+
+from numpy import inf, sin, cos
+
+name = "core_shell_bicelle_elliptical"
+title = "Elliptical cylinder with a core-shell scattering length density profile.."
+description = """
+    core_shell_bicelle_elliptical
+    Elliptical cylinder core, optional shell on the two flat faces, and shell of 
+    uniform thickness on its rim (extending around the end faces).    
+    Please see full documentation for equations and further details.
+    Involves a double numerical integral around the ellipsoid diameter
+    and the angle of the cylinder axis to Q.
+    Compare also the core_shell_bicelle and elliptical_cylinder models.
+      """
+category = "shape:cylinder"
+
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["radius",         "Ang",       30, [0, inf],    "volume",      "Cylinder core radius"],
+    ["x_core",        "None",       3,  [0, inf],    "volume",      "axial ratio of core, X = r_polar/r_equatorial"],
+    ["thick_rim",  "Ang",        8, [0, inf],    "volume",      "Rim shell thickness"],
+    ["thick_face", "Ang",       14, [0, inf],    "volume",      "Cylinder face thickness"],
+    ["length",         "Ang",      50, [0, inf],    "volume",      "Cylinder length"],
+    ["sld_core",       "1e-6/Ang^2", 4, [-inf, inf], "sld",         "Cylinder core scattering length density"],
+    ["sld_face",       "1e-6/Ang^2", 7, [-inf, inf], "sld",         "Cylinder face scattering length density"],
+    ["sld_rim",        "1e-6/Ang^2", 1, [-inf, inf], "sld",         "Cylinder rim scattering length density"],
+    ["sld_solvent",    "1e-6/Ang^2", 6, [-inf, inf], "sld",         "Solvent scattering length density"],
+    ["theta",          "degrees",   90, [-360, 360], "orientation", "In plane angle"],
+    ["phi",            "degrees",    0, [-360, 360], "orientation", "Out of plane angle"],
+    ["psi",            "degrees",    0, [-360, 360], "orientation", "Major axis angle relative to Q"],
+    ]
+
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["lib/sas_Si.c", "lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c",
+          "core_shell_bicelle_elliptical.c"]
+
+demo = dict(scale=1, background=0,
+            radius=30.0,
+            x_core=3.0,
+            thick_rim=8.0,
+            thick_face=14.0,
+            length=50.0,
+            sld_core=4.0,
+            sld_face=7.0,
+            sld_rim=1.0,
+            sld_solvent=6.0,
+            theta=90,
+            phi=0,
+            psi=0)
+
+#qx, qy = 0.4 * cos(pi/2.0), 0.5 * sin(0)
+
+tests = [
+    [{'radius': 30.0, 'x_core': 3.0, 'thick_rim':8.0, 'thick_face':14.0, 'length':50.0}, 'ER', 1],
+    [{'radius': 30.0, 'x_core': 3.0, 'thick_rim':8.0, 'thick_face':14.0, 'length':50.0}, 'VR', 1],
+
+    [{'radius': 30.0, 'x_core': 3.0, 'thick_rim':8.0, 'thick_face':14.0, 'length':50.0,
+    'sld_core':4.0, 'sld_face':7.0, 'sld_rim':1.0, 'sld_solvent':6.0, 'background':0.0},
+    0.015, 286.540286],
+]
Index: sasmodels/models/core_shell_cylinder.c
===================================================================
--- sasmodels/models/core_shell_cylinder.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/core_shell_cylinder.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -5,18 +5,16 @@
     double radius, double thickness, double length, double theta, double phi);
 
-// twovd = 2 * volume * delta_rho
+// vd = volume * delta_rho
 // besarg = q * R * sin(alpha)
 // siarg = q * L/2 * cos(alpha)
-double _cyl(double twovd, double besarg, double siarg);
-double _cyl(double twovd, double besarg, double siarg)
+double _cyl(double vd, double besarg, double siarg);
+double _cyl(double vd, double besarg, double siarg)
 {
-    const double bj = (besarg == 0.0 ? 0.5 : 0.5*sas_J1c(besarg));
-    const double si = (siarg == 0.0 ? 1.0 : sin(siarg)/siarg);
-    return twovd*si*bj;
+    return vd * sas_sinx_x(siarg) * sas_2J1x_x(besarg);
 }
 
 double form_volume(double radius, double thickness, double length)
 {
-    return M_PI*(radius+thickness)*(radius+thickness)*(length+2*thickness);
+    return M_PI*(radius+thickness)*(radius+thickness)*(length+2.0*thickness);
 }
 
@@ -32,10 +30,8 @@
     const double core_qr = q*radius;
     const double core_qh = q*0.5*length;
-    const double core_twovd = 2.0 * form_volume(radius,0,length)
-                            * (core_sld-shell_sld);
+    const double core_vd = form_volume(radius,0,length) * (core_sld-shell_sld);
     const double shell_qr = q*(radius + thickness);
     const double shell_qh = q*(0.5*length + thickness);
-    const double shell_twovd = 2.0 * form_volume(radius,thickness,length)
-                             * (shell_sld-solvent_sld);
+    const double shell_vd = form_volume(radius,thickness,length) * (shell_sld-solvent_sld);
     double total = 0.0;
     // double lower=0, upper=M_PI_2;
@@ -46,6 +42,6 @@
         const double alpha = 0.5*(Gauss76Z[i]*M_PI_2 + M_PI_2);
         SINCOS(alpha, sn, cn);
-        const double fq = _cyl(core_twovd, core_qr*sn, core_qh*cn)
-            + _cyl(shell_twovd, shell_qr*sn, shell_qh*cn);
+        const double fq = _cyl(core_vd, core_qr*sn, core_qh*cn)
+            + _cyl(shell_vd, shell_qr*sn, shell_qh*cn);
         total += Gauss76Wt[i] * fq * fq * sn;
     }
@@ -66,27 +62,16 @@
     double phi)
 {
-    double sn, cn; // slots to hold sincos function output
-
-    // Compute angle alpha between q and the cylinder axis
-    SINCOS(phi*M_PI_180, sn, cn);
-    // # The following correction factor exists in sasview, but it can't be
-    // # right, so we are leaving it out for now.
-    // const double correction = fabs(cn)*M_PI_2;
-    const double q = sqrt(qx*qx+qy*qy);
-    const double cos_val = (q==0. ? 1.0 : (cn*qx + sn*qy)*sin(theta*M_PI_180)/q);
-    const double alpha = acos(cos_val);
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
 
     const double core_qr = q*radius;
     const double core_qh = q*0.5*length;
-    const double core_twovd = 2.0 * form_volume(radius,0,length)
-                            * (core_sld-shell_sld);
+    const double core_vd = form_volume(radius,0,length) * (core_sld-shell_sld);
     const double shell_qr = q*(radius + thickness);
     const double shell_qh = q*(0.5*length + thickness);
-    const double shell_twovd = 2.0 * form_volume(radius,thickness,length)
-                             * (shell_sld-solvent_sld);
+    const double shell_vd = form_volume(radius,thickness,length) * (shell_sld-solvent_sld);
 
-    SINCOS(alpha, sn, cn);
-    const double fq = _cyl(core_twovd, core_qr*sn, core_qh*cn)
-        + _cyl(shell_twovd, shell_qr*sn, shell_qh*cn);
+    const double fq = _cyl(core_vd, core_qr*sin_alpha, core_qh*cos_alpha)
+        + _cyl(shell_vd, shell_qr*sin_alpha, shell_qh*cos_alpha);
     return 1.0e-4 * fq * fq;
 }
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision 40a87fa5096610e24c3ead10299f609e99f093f2)
+++ sasmodels/models/core_shell_cylinder.py	(revision 8e68ea06a7246c4bd95ce82c755719ced6fa5a60)
@@ -1,16 +1,13 @@
-# core shell cylinder model
-# Note: model title and parameter table are inserted automatically
 r"""
-The form factor is normalized by the particle volume.
-
 Definition
 ----------
 
 The output of the 2D scattering intensity function for oriented core-shell
-cylinders is given by (Kline, 2006)
+cylinders is given by (Kline, 2006 [#kline]_). The form factor is normalized
+by the particle volume.
 
 .. math::
 
-    I(q,\alpha) = \frac{\text{scale}}{V_s} F^2(q) + \text{background}
+    I(q,\alpha) = \frac{\text{scale}}{V_s} F^2(q,\alpha).sin(\alpha) + \text{background}
 
 where
@@ -18,5 +15,5 @@
 .. math::
 
-    F(q) = &\ (\rho_c - \rho_s) V_c
+    F(q,\alpha) = &\ (\rho_c - \rho_s) V_c
            \frac{\sin \left( q \tfrac12 L\cos\alpha \right)}
                 {q \tfrac12 L\cos\alpha}
@@ -61,21 +58,17 @@
 The $\theta$ and $\phi$ parameters are not used for the 1D output.
 
-Validation
-----------
-
-Validation of our code was done by comparing the output of the 1D model to
-the output of the software provided by the NIST (Kline, 2006).
-
-Averaging over a distribution of orientation is done by evaluating the
-equation above. Since we have no other software to compare the
-implementation of the intensity for fully oriented cylinders, we
-compared the result of averaging our 2D output using a uniform
-distribution $p(\theta,\phi) = 1.0$.
-
 Reference
 ---------
-see, for example, Ian Livsey  J. Chem. Soc., Faraday Trans. 2, 1987,83, 1445-1452
 
-2016/03/18 - Description reviewed by RKH
+.. [#] see, for example, Ian Livsey  J. Chem. Soc., Faraday Trans. 2, 1987,83,
+   1445-1452
+.. [#kline] S R Kline, *J Appl. Cryst.*, 39 (2006) 895
+
+Authorship and Verification
+----------------------------
+
+* **Author:** NIST IGOR/DANSE **Date:** pre 2010
+* **Last Modified by:** Paul Kienzle **Date:** Aug 8, 2016
+* **Last Reviewed by:** Richard Heenan **Date:** March 18, 2016
 """
 
@@ -158,3 +151,3 @@
             theta_pd=15, theta_pd_n=45,
             phi_pd=15, phi_pd_n=1)
-# ADDED by:  RKH  ON: 18Mar2016 renamed sld's etc
+
Index: sasmodels/models/core_shell_ellipsoid.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/core_shell_ellipsoid.c	(revision 0a3d9b2c366d93b98a02e5c9077f26098e630bd0)
@@ -32,5 +32,5 @@
     const double equat_shell = radius_equat_core + thick_shell;
     const double polar_shell = radius_equat_core*x_core + thick_shell*x_polar_shell;
-    double vol = 4.0*M_PI/3.0*equat_shell*equat_shell*polar_shell;
+    double vol = M_4PI_3*equat_shell*equat_shell*polar_shell;
     return vol;
 }
@@ -49,5 +49,4 @@
     const double uplim = 1.0;
 
-    double summ = 0.0;	 //initialize intergral
 
     const double delpc = core_sld - shell_sld; //core - shell
@@ -59,26 +58,19 @@
     const double polar_shell = radius_equat_core*x_core + thick_shell*x_polar_shell;
 
-    for(int i=0;i<N_POINTS_76;i++) {
-        double zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
-        double yyy = Gauss76Wt[i] * gfn4(zi,
-                                  radius_equat_core,
-                                  polar_core,
-                                  equat_shell,
-                                  polar_shell,
-                                  delpc,
-                                  delps,
-                                  q);
-        summ += yyy;
+    double summ = 0.0;	 //initialize intergral
+    for(int i=0;i<76;i++) {
+        double zi = 0.5*( Gauss76Z[i]*(uplim-lolim) + uplim + lolim );
+        double yyy = gfn4(zi, radius_equat_core, polar_core, equat_shell,
+                          polar_shell, delpc, delps, q);
+        summ += Gauss76Wt[i] * yyy;
     }
+    summ *= 0.5*(uplim-lolim);
 
-    double answer = (uplim-lolim)/2.0*summ;
-    //convert to [cm-1]
-    answer *= 1.0e-4;
-
-    return answer;
+    // convert to [cm-1]
+    return 1.0e-4 * summ;
 }
 
 static double
-core_shell_ellipsoid_xt_kernel_2d(double q, double q_x, double q_y,
+core_shell_ellipsoid_xt_kernel_2d(double qx, double qy,
           double radius_equat_core,
           double x_core,
@@ -91,18 +83,9 @@
           double phi)
 {
-    //convert angle degree to radian
-    theta = theta * M_PI_180;
-    phi = phi * M_PI_180;
-
-    // ellipsoid orientation, the axis of the rotation is consistent with the ploar axis.
-    const double cyl_x = sin(theta) * cos(phi);
-    const double cyl_y = sin(theta) * sin(phi);
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
 
     const double sldcs = core_sld - shell_sld;
     const double sldss = shell_sld- solvent_sld;
-
-    // Compute the angle btw vector q and the
-    // axis of the cylinder
-    const double cos_val = cyl_x*q_x + cyl_y*q_y;
 
     const double polar_core = radius_equat_core*x_core;
@@ -112,5 +95,5 @@
     // Call the IGOR library function to get the kernel:
     // MUST use gfn4 not gf2 because of the def of params.
-    double answer = gfn4(cos_val,
+    double answer = gfn4(cos_alpha,
                   radius_equat_core,
                   polar_core,
@@ -160,7 +143,5 @@
           double phi)
 {
-    double q;
-    q = sqrt(qx*qx+qy*qy);
-    double intensity = core_shell_ellipsoid_xt_kernel_2d(q, qx/q, qy/q,
+    double intensity = core_shell_ellipsoid_xt_kernel_2d(qx, qy,
                        radius_equat_core,
                        x_core,
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision ef5a3145c555427a3626384f3a1ca07763f4d48f)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision 8e68ea06a7246c4bd95ce82c755719ced6fa5a60)
@@ -125,5 +125,5 @@
 #             ["name", "units", default, [lower, upper], "type", "description"],
 parameters = [
-    ["radius_equat_core","Ang",     20,   [0, inf],    "volume",      "Equatorial radius of core"],
+    ["radius_equat_core","Ang",     20,   [0, inf],   "volume",      "Equatorial radius of core"],
     ["x_core",        "None",       3,   [0, inf],    "volume",      "axial ratio of core, X = r_polar/r_equatorial"],
     ["thick_shell",   "Ang",       30,   [0, inf],    "volume",      "thickness of shell at equator"],
@@ -137,5 +137,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/gfn.c", "lib/gauss76.c",
+source = ["lib/sas_3j1x_x.c", "lib/gfn.c", "lib/gauss76.c",
           "core_shell_ellipsoid.c"]
 
@@ -162,46 +162,52 @@
 
 q = 0.1
-phi = pi/6
-qx = q*cos(phi)
-qy = q*sin(phi)
-# After redefinition of angles find new reasonable values for unit test
-#tests = [
-#    # Accuracy tests based on content in test/utest_coreshellellipsoidXTmodel.py
-#    [{'radius_equat_core': 200.0,
-#      'x_core': 0.1,
-#      'thick_shell': 50.0,
-#      'x_polar_shell': 0.2,
-#      'sld_core': 2.0,
-#      'sld_shell': 1.0,
-#      'sld_solvent': 6.3,
-#      'background': 0.001,
-#      'scale': 1.0,
-#     }, 1.0, 0.00189402],
+# tests had in old coords theta=0, phi=0; new coords theta=90, phi=0
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+# 11Jan2017 RKH sorted tests after redefinition of angles
+tests = [
+     # Accuracy tests based on content in test/utest_coreshellellipsoidXTmodel.py
+    [{'radius_equat_core': 200.0,
+      'x_core': 0.1,
+      'thick_shell': 50.0,
+      'x_polar_shell': 0.2,
+      'sld_core': 2.0,
+      'sld_shell': 1.0,
+      'sld_solvent': 6.3,
+      'background': 0.001,
+      'scale': 1.0,
+     }, 1.0, 0.00189402],
 
     # Additional tests with larger range of parameters
-#    [{'background': 0.01}, 0.1, 11.6915],
-
-#    [{'radius_equat_core': 20.0,
-#      'x_core': 200.0,
-#      'thick_shell': 54.0,
-#      'x_polar_shell': 3.0,
-#      'sld_core': 20.0,
-#      'sld_shell': 10.0,
-#      'sld_solvent': 6.0,
-#      'background': 0.0,
-#      'scale': 1.0,
-#     }, 0.01, 8688.53],
-
-#   [{'background': 0.001}, (0.4, 0.5), 0.00690673],
-
-#   [{'radius_equat_core': 20.0,
-#      'x_core': 200.0,
-#      'thick_shell': 54.0,
-#      'x_polar_shell': 3.0,
-#      'sld_core': 20.0,
-#      'sld_shell': 10.0,
-#      'sld_solvent': 6.0,
-#      'background': 0.01,
-#      'scale': 0.01,
-#     }, (qx, qy), 0.0100002],
-#    ]
+    [{'background': 0.01}, 0.1, 11.6915],
+
+    [{'radius_equat_core': 20.0,
+      'x_core': 200.0,
+      'thick_shell': 54.0,
+      'x_polar_shell': 3.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
+      'background': 0.0,
+      'scale': 1.0,
+     }, 0.01, 8688.53],
+
+   # 2D tests
+   [{'background': 0.001,
+     'theta': 90.0,
+     'phi': 0.0,
+     }, (0.4, 0.5), 0.00690673],
+
+   [{'radius_equat_core': 20.0,
+      'x_core': 200.0,
+      'thick_shell': 54.0,
+      'x_polar_shell': 3.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
+      'background': 0.01,
+      'scale': 0.01,
+      'theta': 90.0,
+      'phi': 0.0,
+     }, (qx, qy), 0.01000025],
+    ]
